/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include "wirednodegrid.h"

namespace ns3 {


//get address where to send the data
int WiredNodeGrid::getAddress(WiredNodeGrid* n2) {
	int xx = n2->getX() - this->x;
	int yy = n2->getY() - this->y;

	//std::cout << " y: "<<yy<< " x: "<< xx <<std::endl;

	if (yy < 0 && xx == 0) {
		return n2->getDevice(2, 1);
	}
	if (yy < 0 && xx < 0) {
		return n2->getDevice(2, 1);
	}
	if (yy == 0 && xx < 0) {
		return n2->getDevice(1, 2);
	}
	if (yy > 0 && xx < 0) {
		return n2->getDevice(1, 2);
	}
	if (yy > 0 && xx == 0) {
		return n2->getDevice(0, 1);
	}
	if (yy > 0 && xx > 0) {
		return n2->getDevice(0, 1);
	}
	if (yy == 0 && xx > 0) {
		return n2->getDevice(1, 0);
	}
	if (yy < 0 && xx > 0) {
		return n2->getDevice(1, 0);
	}
	return 0;
}

//get address where to send the data 
NetDeviceContainer WiredNodeGrid::getNetDevByNode(WiredNode* n2){
	int xx = n2->getX() - this->x;
	int yy = n2->getY() - this->y;
	
	//std::cout << " y: "<<yy<< " x: "<< xx <<std::endl;

	if(yy<0 && xx==0){
		return n2->getNetDevice(2,1);
	}
	if(yy<0 && xx<0){
		return n2->getNetDevice(2,1);
	}
	if(yy==0 && xx<0){
		return n2->getNetDevice(1,2);
	}
	if(yy>0 && xx<0){
		return n2->getNetDevice(1,2);
	}
	if(yy>0 && xx==0){
		return n2->getNetDevice(0,1);
	}
	if(yy>0 && xx>0){
		return n2->getNetDevice(0,1);
	}
	if(yy==0 && xx>0){
		return n2->getNetDevice(1,0);
	}
	if(yy<0 && xx>0){
		return n2->getNetDevice(1,0);
	}
	return NetDeviceContainer();
}

}