/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef PROTOCOLHEADER_H
#define PROTOCOLHEADER_H

#include <fstream>
#include <iostream>
#include <string>
#include "ns3/header.h"
#include "ns3/network-module.h"

#include "ns3/packet.h"

#include "ns3/timepacket.pb.h"

namespace ns3 {

	class GridHeader : public Header
	{	
	public:

		 // new methods
  		void SetData (timepacket::pHeader packetT);
  		timepacket::pHeader GetData (void);

		static TypeId GetTypeId (void);
		GridHeader ();
		GridHeader (timepacket::pHeader packetT);
		virtual~GridHeader ();

		virtual TypeId GetInstanceTypeId (void) const;
		
		virtual uint32_t GetSerializedSize (void) const;
   		virtual void Serialize (Buffer::Iterator start) const;
   		virtual uint32_t Deserialize (Buffer::Iterator start);
        virtual void Print (std::ostream &os) const;
		
        timepacket::pHeader pTime;
	};
}

#endif /* PROTOCOLHEADER_H */